
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.PrepareMR &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.PrepareMR</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="PrepareMR_exception"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR_exception">[docs]</a><span class="k">class</span> <span class="nc">PrepareMR_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">PrepareMR_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="PrepareMR"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR">[docs]</a><span class="k">class</span> <span class="nc">PrepareMR</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;DREnsembler&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.PrepareMR {</span>
<span class="s2">max_number_of_ensembles_per_component_for_mr = 3</span>
<span class="s2">     .type = int(value_min=1)</span>
<span class="s2">     .expert_level = 0</span>
<span class="s2">     .optional = True</span>
<span class="s2">     .short_caption = Max number of ensembles in the mr search</span>
<span class="s2">     .help = Define the maximum number of ensembles to be used as alternative in the mr_auto search</span>

<span class="s2">iterative_improvement = True</span>
<span class="s2">  .type = bool</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Iterative improvement of models </span>
<span class="s2">  .help = Try to improve ech component placed before searching for the next one. As opposite if False, it searches all the cmponents and then improve globally the solution.</span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; Select, Sort and organize ensembles into Molecules/Domains to be searched in the correct order by a MR strategy.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;PrepareMR&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">PrepareMR</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>
        
        
<div class="viewcode-block" id="PrepareMR.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">copy</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;copy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;pdb_structure&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">any_file</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.file_reader&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;any_file&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;shutil&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">np</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;numpy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">)</span>


        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="PrepareMR.test"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="PrepareMR.help"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="PrepareMR.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="PrepareMR.run"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">PrepareMR_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span><span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">prepare_mr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="PrepareMR.prepare_mr"><a class="viewcode-back" href="../../../Voyager.Actions.PrepareMR.html#Voyager.Actions.PrepareMR.PrepareMR.prepare_mr">[docs]</a>    <span class="k">def</span> <span class="nf">prepare_mr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span> <span class="n">root</span> <span class="o">=</span> <span class="p">[</span><span class="n">root</span><span class="p">]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">PrepareMR_exception</span><span class="p">(</span><span class="s2">&quot;This action cannot be the root of a PhaserDAG&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">accepted_errors</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="n">return_nodes</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">already_visited</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="k">for</span> <span class="n">ele</span> <span class="ow">in</span> <span class="n">root</span><span class="p">:</span>
            <span class="n">sculpted</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="k">for</span> <span class="n">no</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_nodes_with_pdb_model</span><span class="p">(</span><span class="n">ele</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;sculpted&quot;</span><span class="p">):</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span><span class="o">==</span><span class="s2">&quot;pdb&quot;</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">]</span> <span class="ow">in</span> <span class="n">sculpted</span><span class="p">:</span>
                        <span class="n">sculpted</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">]]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">])</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">sculpted</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">]]</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">no</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">]]</span>

            <span class="n">elements</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_nodes_with_ensembles_clustered_models</span><span class="p">(</span><span class="n">ele</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">elements</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span> <span class="k">continue</span>
            <span class="n">model_containers</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">([</span><span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">x</span><span class="p">))[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">elements</span><span class="p">]))</span>
            <span class="k">if</span> <span class="nb">any</span><span class="p">([</span><span class="nb">set</span><span class="p">(</span><span class="n">model_containers</span><span class="p">)</span> <span class="o">==</span> <span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">already_visited</span><span class="p">]):</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">already_visited</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">model_containers</span><span class="p">))</span>

            <span class="n">basedir</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">create_directory_timestamp</span><span class="p">(</span><span class="s2">&quot;preparemr_&quot;</span><span class="p">)</span>
            <span class="n">groups</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="n">all_ensembles</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="k">for</span> <span class="n">model_container</span> <span class="ow">in</span> <span class="n">model_containers</span><span class="p">:</span>
                <span class="n">subgroup</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">model_container</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">])</span>
                <span class="n">elename</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">model_container</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">]</span>
                <span class="n">component</span><span class="p">,</span> <span class="n">domain</span> <span class="o">=</span> <span class="n">elename</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;-&quot;</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">component</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">groups</span><span class="p">:</span>
                    <span class="n">groups</span><span class="p">[</span><span class="n">component</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="n">domain</span><span class="p">:</span> <span class="p">[]}</span>
                    <span class="n">all_ensembles</span><span class="p">[</span><span class="n">component</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="n">domain</span><span class="p">:</span> <span class="p">[]}</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">groups</span><span class="p">[</span><span class="n">component</span><span class="p">][</span><span class="n">domain</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
                    <span class="n">all_ensembles</span><span class="p">[</span><span class="n">component</span><span class="p">][</span><span class="n">domain</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>

                <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">subgroup</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">subgroup</span><span class="p">)</span>
                <span class="n">pdblist</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="n">candidates</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="k">for</span> <span class="n">el</span> <span class="ow">in</span> <span class="n">elements</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;pdb&quot;</span> <span class="ow">and</span> <span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">el</span><span class="p">))[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">model_container</span><span class="p">:</span>
                        <span class="n">candidates</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="nb">float</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;probability&quot;</span><span class="p">]),</span>
                                           <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;label&quot;</span><span class="p">],</span>
                                           <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;name&quot;</span><span class="p">],</span>
                                           <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">]))</span>

                <span class="n">all_ensembles</span><span class="p">[</span><span class="n">component</span><span class="p">][</span><span class="n">domain</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="n">candidates</span><span class="p">)</span>

                <span class="n">candidates</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">candidates</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)[</span>
                             <span class="p">:</span><span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">PrepareMR</span><span class="o">.</span><span class="n">max_number_of_ensembles_per_component_for_mr</span><span class="p">]</span>

                <span class="k">for</span> <span class="n">candi</span> <span class="ow">in</span> <span class="n">candidates</span><span class="p">:</span>
                    <span class="n">ttt</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="n">candi</span><span class="p">[</span><span class="mi">3</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="n">subgroup</span><span class="p">,</span> <span class="n">filename</span><span class="o">=</span><span class="n">candi</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;::&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span><span class="o">+</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)</span>
                    <span class="n">groups</span><span class="p">[</span><span class="n">component</span><span class="p">][</span><span class="n">domain</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">candi</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">ttt</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
                    <span class="n">pdblist</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ttt</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>

            <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">groups</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="nb">print</span><span class="p">(</span><span class="n">key</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">n</span><span class="p">,</span> <span class="n">it</span> <span class="ow">in</span> <span class="n">item</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">n</span><span class="p">)</span>
                    <span class="k">for</span> <span class="n">ll</span> <span class="ow">in</span> <span class="n">it</span><span class="p">:</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\t\t</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">ll</span><span class="p">)</span>

            <span class="n">datanode</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_hkl_data</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="n">combination</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">datanode</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">]</span>
            <span class="c1">#print(&quot;COMBINATION&quot;,combination[&quot;combination&quot;])</span>
            <span class="c1">#####mtz = self.schedule_extract_from_db(self.voyager_dag.nodes(datanode)[&quot;data_identifier&quot;], in_memory=False)[0]</span>

            <span class="n">searches</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">molecule</span><span class="p">,</span> <span class="n">di</span> <span class="ow">in</span> <span class="n">groups</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">for</span> <span class="n">domain</span><span class="p">,</span> <span class="n">pdblist</span> <span class="ow">in</span> <span class="n">di</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="n">name</span> <span class="o">=</span> <span class="n">molecule</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">+</span> <span class="n">domain</span>
                    <span class="k">if</span> <span class="n">molecule</span> <span class="ow">in</span> <span class="n">combination</span><span class="p">[</span><span class="s2">&quot;combination&quot;</span><span class="p">]:</span>
                        <span class="n">searches</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">name</span><span class="p">,</span> <span class="nb">max</span><span class="p">([</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">pdblist</span><span class="p">]),</span> <span class="n">combination</span><span class="p">[</span><span class="s2">&quot;combination&quot;</span><span class="p">][</span><span class="n">molecule</span><span class="p">][</span><span class="s2">&quot;nasu&quot;</span><span class="p">],</span> <span class="p">[</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="s2">&quot;./&quot;</span><span class="o">+</span><span class="n">name</span><span class="p">,</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">pdblist</span><span class="p">]])</span>
            <span class="n">searches</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">searches</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="c1">#print(&quot;LEN(SEARCHES)&quot;,len(searches))</span>

            <span class="n">spg</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">get_node_object_from_phil</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">datanode</span><span class="p">)[</span><span class="s2">&quot;dag_phil&quot;</span><span class="p">])</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">node</span><span class="o">.</span><span class="n">spacegroup</span>
            <span class="n">spg</span> <span class="o">=</span> <span class="n">spg</span><span class="o">.</span><span class="n">type</span><span class="p">()</span><span class="o">.</span><span class="n">number</span><span class="p">()</span>
            <span class="n">nroot</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_voyager</span><span class="p">(</span><span class="s2">&quot;molecules&quot;</span><span class="p">,</span> <span class="n">datanode</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="p">{</span><span class="s2">&quot;sculpted&quot;</span><span class="p">:</span><span class="n">sculpted</span><span class="p">,</span> <span class="s2">&quot;spacegroup&quot;</span><span class="p">:</span><span class="n">spg</span><span class="p">,</span> <span class="s2">&quot;all_ensembles&quot;</span><span class="p">:</span><span class="n">all_ensembles</span><span class="p">,</span><span class="s2">&quot;searches&quot;</span><span class="p">:</span><span class="n">searches</span><span class="p">,</span><span class="s2">&quot;mw&quot;</span><span class="p">:</span><span class="n">combination</span><span class="p">[</span><span class="s2">&quot;molecular_weight&quot;</span><span class="p">],</span> <span class="s2">&quot;nc&quot;</span><span class="p">:</span><span class="n">combination</span><span class="p">[</span><span class="s2">&quot;number_of_components&quot;</span><span class="p">]},</span> <span class="n">probability</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">ilo</span><span class="p">,</span> <span class="n">search</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">searches</span><span class="p">):</span>
                <span class="n">ready</span> <span class="o">=</span> <span class="kc">False</span>
                <span class="n">done</span> <span class="o">=</span> <span class="kc">False</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">PrepareMR</span><span class="o">.</span><span class="n">iterative_improvement</span> <span class="ow">and</span> <span class="n">ilo</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span> <span class="n">ready</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">PrepareMR</span><span class="o">.</span><span class="n">iterative_improvement</span><span class="p">:</span> <span class="n">ready</span> <span class="o">=</span> <span class="kc">False</span>
                <span class="k">else</span><span class="p">:</span> <span class="n">ready</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="n">proot</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_voyager</span><span class="p">(</span><span class="n">search</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">nroot</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="p">[</span><span class="n">search</span><span class="p">],</span> <span class="n">probability</span><span class="o">=-</span><span class="mi">1</span><span class="o">*</span><span class="n">ilo</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ready</span><span class="o">=</span><span class="n">ready</span><span class="p">,</span> <span class="n">done</span><span class="o">=</span><span class="n">done</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_model</span><span class="p">([</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">search</span><span class="p">[</span><span class="mi">3</span><span class="p">]],</span> <span class="s2">&quot;ensembles&quot;</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="n">proot</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">probability</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>
            <span class="n">return_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">nroot</span><span class="p">)</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">basedir</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">return_nodes</span></div></div>




</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>